package com.css.simulation.oauth.server.cofiguration.oauth;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.security.oauth2.provider.ClientDetailsService;
import org.springframework.security.oauth2.provider.token.AuthorizationServerTokenServices;
import org.springframework.security.oauth2.provider.token.DefaultTokenServices;
import org.springframework.security.oauth2.provider.token.TokenStore;

import javax.annotation.Resource;

@Configuration
public class MyTokenService {

    @Resource
    private ClientDetailsService clientDetailsService;  // 客户端详情服务


    @Resource
    private TokenStore tokenStore;  // 客户端详情服务


    /**
     * 令牌管理策略
     */
    @Bean
    public AuthorizationServerTokenServices authorizationServerTokenServices() {
        DefaultTokenServices services = new DefaultTokenServices();
        services.setClientDetailsService(clientDetailsService);     // 客户端详情服务，获取 ClientDetailsServiceConfigurer 中配置的客户端
        services.setSupportRefreshToken(true);      // 允许令牌自动刷新
        services.setTokenStore(tokenStore);         // 令牌存储策略
        services.setAccessTokenValiditySeconds(7200);   // 令牌默认有效期 2 小时
        services.setRefreshTokenValiditySeconds(259200);    // 刷新令牌默认有效期 3 天。
        return services;
    }

}
