package com.css.simulation.resource.scheduler.feign;

import api.common.pojo.common.ResponseBodyVO;
import com.css.simulation.resource.scheduler.configuration.feign.OpenFeignConfiguration;
import com.css.simulation.resource.scheduler.feign.fallback.DemoServiceFallback;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

@Component
//@FeignClient(value = "http://10.15.12.74:8001", fallback = DemoServiceFallback.class, configuration = OpenFeignConfiguration.class)
@FeignClient(
        value = "simulation-resource-common",
        fallback = DemoServiceFallback.class,
        configuration = OpenFeignConfiguration.class
)
public interface DemoService {

    @PostMapping(value = "/simulation/resource/common/minio/upload", consumes = MediaType.MULTIPART_FORM_DATA_VALUE)
    ResponseBodyVO<String> upload(@RequestPart("file") MultipartFile file,
                                  @RequestParam("bucketName") String bucketName,
                                  @RequestParam("objectName") String objectName);


}
